> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-881012b3.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# TPV S2S Integration - UPI Intent Flow

> Integrate TPV using S2S integration with UPI Intent Flow.

<div style={{display:"flex",flexWrap:"wrap",alignItems:"center",gap:"0.35rem 0.9rem",border:"1px solid rgba(128,128,128,0.28)",borderRadius:"0.5rem",padding:"0.45rem 0.75rem",margin:"0 0 1.25rem",fontSize:"0.875rem"}}>
  <span style={{fontWeight:600}}>Available in</span>
  <span>🇮🇳 India</span>
</div>

You can collect payments using the UPI Intent Flow. In this flow, when customer selects UPI as the payment method, the list of UPI PSP apps is displayed. When the customer selects their preferred app, it opens automatically. They can complete the payment on the UPI PSP app.

## Best Practices

Following are a few of the best practices to be followed to accept online payments using UPI Intent Flow:

1. **Do not change Intent URL** <br />
   Do not make changes to the intent URL shared by Razorpay as part of the API response. Making changes to the intent URL can lead to payment failure.
2. **Host UPI apps** <br />
   It is recommended to host the UPI apps on your page/app instead of just hosting the Intent URI where the native Android drawer shows the apps. This improves conversion.
3. **Rank UPI Apps by Success Rate** <br />
   Show the UPI PSP apps in the order of their success rate.
4. **Mobile site**  <br />
   If you have higher traffic via mobile site, make sure you provide the option of UPI intent payment to your users using [our m-site integration](/docs/payments/payment-methods/upi/google-pay/custom-integration). This will help you achieve better success rates.
5. **Gpay SDK** <br />
   If your UPI transaction volumes are high, you can also explore integrating [Gpay SDK](/docs/payments/payment-methods/upi/google-pay#android-integration-using-google-pay-sdk). This provides a better user experience and about a 3-5% improvement in success rate.

## Prerequisites

* Contact our [Support Team](https://razorpay.com/support/#raise-a-request) to get this feature enabled for your account.
* Keep the API key (combination of `Key_Id` and `Key_Secret`) handy for integration.
* [Generate API Keys from the Dashboard](/docs/api/authentication#generate-api-keys) if you have not done already.
* Configure the [payment capture settings](/docs/payments/payments/capture-settings) on the Dashboard.

## UPI Intent Flow

Following is the process for accepting payments using the UPI Intent Flow:

Customers need not enter VPA or phone number as these details are pre-filled and submitted along with the other payment details. While making the payment, customers select the UPI PSP app on your app. The UPI PSP app is launched automatically on their mobile devices, where the payment is completed.

1. The customer selects UPI as the payment method.
2. The customer chooses their preferred UPI PSP app from the list.
3. The UPI PSP app opens automatically and the customer completes the payment.

## Integration Steps

1. [Create an order](#step-1-create-an-order).
2. [Initiate Payment using the intent URL](#step-2-initiate-a-payment).
3. [Store Fields in Your Server](#step-3-store-fields-in-your-server).
4. [Verify the Signature](#step-4-verify-the-signature).

### Step 1: Create an Order

`POST /orders`

Given below is the sample code when `method` is `upi`.

<CodeGroup>
  ```bash Curl theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET> \
  -X POST https://api.razorpay.com/v1/orders \
  -H "Content-Type: application/json" \
  -d '{
    "amount": 100,
    "method": "upi",
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": {
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053"
    }
  }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      JSONObject orderRequest = new JSONObject();
      orderRequest.put("amount", 100); // amount in the smallest currency unit
      orderRequest.put("currency", "INR");
      orderRequest.put("receipt", "BILL13375649");
      orderRequest.put("method", "upi");

      JSONObject bank_account = new JSONObject();
      bank_account.put("account_number", "765432123456789");
      bank_account.put("name", "Gaurav Kumar");
      bank_account.put("ifsc, "HDFC0000053");
      orderRequest.put("bank_account", bank_account);

      Order order = razorpayclient.orders.create(orderRequest);
      System.out.print(order);
          
  ```

  ```python Python theme={null}
  import razorpay
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.order.create({
  {
    "amount": 100,
    "method": "upi",
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": {
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053"
    }
   })
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->order->create(array('amount' => 100, 'receipt' => 'BILL13375649', 'method' => 'upi', 'currency' => 'INR', 'bank_account'=> array('account_number'=> '765432123456789','name'=> 'Gaurav Kumar','ifsc'=>'HDFC0000053')));
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  Dictionary<string, object> orderRequest = new Dictionary<string, object>();
  orderRequest.Add("amount", 100);
  orderRequest.Add("method", "upi");
  orderRequest.Add("currency", "INR");
  orderRequest.Add("receipt", "receipt#1");
  Dictionary<string, object> bankAccount = new Dictionary<string, object>();
  bankAccount.Add("account_number","765432123456789");
  bankAccount.Add("name","Gaurav Kumar");
  bankAccount.Add("ifsc","HDFC0000053");
  orderRequest.Add("bank_account", bankAccount);

  Order order = client.Order.Create(orderRequest);
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
    "amount": 100,
    "method": "upi",
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": {
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053"
    }
  }  

  Razorpay::Order.create(para_attr)
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.orders.create({
    "amount": 100,
    "method": "upi",
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": {
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053"
    }
  })
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data := map[string]interface{}{
    "amount": 100,
    "method": "upi",
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": map[string]interface{}{
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053",
    },
  }

  body, err := client.Order.Create(data, nil)
  ```

  ```json Response theme={null}
  {
    "id": "order_GAWN9beXgaqRyO",
    "entity": "order",
    "amount": 100,
    "amount_paid": 0,
    "amount_due": 500,
    "currency": "INR",
    "receipt": "BILL13375649",
    "offer_id": null,
    "status": "created",
    "attempts": 0,
    "notes": [],
    "created_at": 1573044247
  }
  ```
</CodeGroup>

<Warning>
  **Watch Out!**

  If you are a TPV business using the Consolidated Payment API, you must pass `method=upi` in **both** of the following:

  1. The **Create Order** request (`/v1/orders`) shown in the [sample above](#step-1-create-an-order).
  2. The **Initiate Payment** request (`/v1/payments/create/upi`) covered in [Step 2](#step-2-initiate-a-payment).

  Omitting `method=upi` from the payment initiation request causes an `invalid bank code` error, particularly for long-tail banks. This applies even if `method` is correctly set at the order level.
</Warning>

If the user selects the payment method within the Razorpay UI, there is no need to include the `method` field. Below is a sample code for reference.

<CodeGroup>
  ```bash Curl theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET> \
  -X POST https://api.razorpay.com/v1/orders \
  -H "Content-Type: application/json" \
  -d '{
    "amount": 100,
    "receipt": "BILL13375649",
    "currency": "INR",
    "bank_account": {
      "account_number": "765432123456789",
      "name": "Gaurav Kumar",
      "ifsc": "HDFC0000053"
    }
  }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject orderRequest = new JSONObject();
  orderRequest.put("amount",100);
  orderRequest.put("currency","INR");
  orderRequest.put("receipt", "receipt#1");
  JSONObject notes = new JSONObject();
  notes.put("notes_key_1","Tea, Earl Grey, Hot");
  notes.put("notes_key_1","Tea, Earl Grey, Hot");
  orderRequest.put("notes",notes);

  Order order = instance.orders.create(orderRequest);
          
  ```

  ```python Python theme={null}
  import razorpay
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.order.create({
    "amount": 100,
    "currency": "INR",
    "receipt": "receipt#1",
    "partial_payment":False,
    "notes": {
      "key1": "value3",
      "key2": "value2"
    }
  })
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->order->create(array('receipt' => '123', 'amount' => 100, 'currency' => 'INR', 'notes'=> array('key1'=> 'value3','key2'=> 'value2')));
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  Dictionary<string, object> orderRequest = new Dictionary<string, object>();
  orderRequest.Add("amount", 100);
  orderRequest.Add("currency", "INR");
  orderRequest.Add("receipt", "receipt#1");
  Dictionary<string, object> notes = new Dictionary<string, object>();
  notes.Add("notes_key_1", "Tea, Earl Grey, Hot");
  notes.Add("notes_key_2", "Tea, Earl Grey, Hot");
  orderRequest.Add("notes", notes);

  Order order = client.Order.Create(orderRequest);
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
    "amount": 100,
    "currency": "INR",
    "receipt": "receipt#1",
    "notes": {
      "key1": "value3",
      "key2": "value2"
    }
  }

  Razorpay::Order.create(para_attr)
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.orders.create({
    "amount": 100,
    "currency": "INR",
    "receipt": "receipt#1",
    "partial_payment": false,
    "notes": {
      "key1": "value3",
      "key2": "value2"
    }
  })
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data := map[string]interface{}{
    "amount": 100,
    "currency": "INR",
    "receipt": "some_receipt_id",
    "partial_payment": false,
    "notes": map[string]interface{}{
        "key1": "value1",
        "key2": "value2",
      },
  }
  body, err := client.Order.Create(data, nil)
  ```

  ```json Response theme={null}
  {
    "id": "order_GAWRjlWkVcRh0V",
    "entity": "order",
    "amount": 100,
    "amount_paid": 0,
    "amount_due": 100,
    "currency": "INR",
    "receipt": "BILL13375649",
    "offer_id": null,
    "status": "created",
    "attempts": 0,
    "notes": [],
    "created_at": 1573044206
  }
  ```
</CodeGroup>

#### Request Parameters

`amount` *mandatory*
: `integer` The transaction amount expressed in paise (currency supported is INR). For example, for an actual amount of ₹1, the value of this field should be `100`.

`currency` *mandatory*
: `string` The currency in which the transaction should be made. You can create orders in **INR** only.

`receipt` *optional*
: `string` Receipt number that corresponds to this order, set for your internal reference. Maximum length is 40 characters.

`notes` *optional*
: `json object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`method` *mandatory*
: `string` The payment method used to make the payment. If this parameter is not passed, investors will be able to make payments using both netbanking and UPI payment methods. Possible values:

* `netbanking`: Investors can make payments only using netbanking.
* `card`: Investors can make payments using debit card.
* `upi`: Investors can make payments only using UPI.

`bank_account` *mandatory*
: `object` Details of the bank account that the investor has provided at the time of registration.

`account_number`  *mandatory*
: `string` The bank account number from which the investor should make the payment. For example, `765432123456789` Payments will not be processed for an incorrect account number.

`name` *mandatory*
: `string` The name linked to the bank account. For example, `Gaurav Kumar`.

`ifsc` *mandatory*
: `string` The bank IFSC. For example, `HDFC0000053`.

### Step 2: Initiate a Payment

`POST /payments/create/upi`

<CodeGroup>
  ```bash Request theme={null}
    curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET> \
    -X POST https://api.razorpay.com/v1/payments/create/upi \
    -H "Content-Type: application/json" \
    -d '{
      "amount": 100,
      "currency": "INR",
      "order_id": "order_Ee0biRtLOqzRjP",
      "email": "gaurav.kumar@example.com",
      "contact": "9000090000",
      "method": "upi",
      "ip": "192.168.0.103",
      "referer": "http",
      "user_agent": "Mozilla/5.0",
      "description": "Test flow",
      "notes": {
        "purpose": "UPI test payment"
      },
      "upi": {
        "flow" : "intent"
      }
    }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject paymentRequest = new JSONObject();
  paymentRequest.put("amount", 100);
  paymentRequest.put("currency", "INR");
  paymentRequest.put("order_id", "order_JZluwjknyWdhnU");
  paymentRequest.put("email", "gaurav.kumar@example.com");
  paymentRequest.put("contact", "9000090000");
  paymentRequest.put("method", "upi");
  paymentRequest.put("ip", "192.168.0.103");
  paymentRequest.put("referer", "http");
  paymentRequest.put("user_agent", "Mozilla/5.0");
  paymentRequest.put("description", "Test flow");
  JSONObject notes = new JSONObject();
  notes.put("purpose", "UPI test payment");
  JSONObject upi = new JSONObject();
  upi.put("flow", "intent");
  paymentRequest.put("notes", notes);
  paymentRequest.put("upi", upi);

  Payment payment = instance.payments.createUpi(paymentRequest);
  ```

  ```python Python theme={null}
  import razorpay
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.payment.createUpi({
      'amount': 100,
      'currency': 'INR',
      'order_id': 'order_Ee0biRtLOqzRjP',
      'email': 'gaurav.kumar@example.com',
      'contact': '9000090000',
      'method': 'upi',
      'ip': '192.168.0.103',
      'referer': 'http',
      'user_agent': 'Mozilla/5.0',
      'description': 'Test flow',
      'notes': {
          'purpose': 'UPI test payment
      '},
      'upi': {
          'flow': 'intent'
      },
  })
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->payment->createUpi(array("amount" => 100,"currency" => "INR","order_id" => "order_Jhgp4wIVHQrg5H","email" => "gaurav.kumar@example.com","contact" => "9000090000","method" => "upi","customer_id" => "cust_EIW4T2etiweBmG","ip" => "192.168.0.103","referer" => "http","user_agent" => "Mozilla/5.0","description" => "Test flow","notes" => array("note_key" => "value1"),"upi" => array("flow" => "intent")));
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient(your_key_id, your_secret);

  Dictionary<string, object> paymentRequest = new Dictionary<string, object>();
  paymentRequest.Add("amount",100);
  paymentRequest.Add("currency","INR");
  paymentRequest.Add("order_id", "order_Z6t7VFTb9xHeOs");
  paymentRequest.Add("email", "gaurav.kumar@example.com");
  paymentRequest.Add("contact", "9000090000");
  paymentRequest.Add("method", "upi");
  paymentRequest.Add("ip", "192.168.0.103");
  paymentRequest.Add("referer", "http");
  paymentRequest.Add("user_agent", "Mozilla/5.0");
  paymentRequest.Add("description", "Test flow");
  Dictionary<string, object> notes = new Dictionary<string, object>();
  notes.Add("purpose","UPI test payment");
  Dictionary<string, object> upi = new Dictionary<string, object>();
  upi.Add("flow","intent");
  paymentRequest.Add("notes",notes);
  paymentRequest.Add("upi",upi);

  Payment payment = client.Payment.CreateUpi(paymentRequest);
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
      "amount": 100,
      "currency": "INR",
      "order_id": "order_Ee0biRtLOqzRjP",
      "email": "gaurav.kumar@example.com",
      "contact": "9000090000",
      "method": "upi",
      "ip": "192.168.0.103",
      "referer": "http",
      "user_agent": "Mozilla/5.0",
      "description": "Test flow",
      "notes": {
        "purpose": "UPI test payment"
      },
      "upi": {
        "flow": "intent"
      }
  }

  Razorpay::Payment.create_upi(para_attr)
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.payments.createUpi({
      "amount": 100,
      "currency": "INR",
      "order_id": "order_Ee0biRtLOqzRjP",
      "email": "gaurav.kumar@example.com",
      "contact": "9000090000",
      "method": "upi",
      "ip": "192.168.0.103",
      "referer": "http",
      "user_agent": "Mozilla/5.0",
      "description": "Test flow",
      "notes": {
          "purpose": "UPI test payment"
      },
      "upi": {
          "flow": "intent"
      }
  });
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  para_attr: = map[string] interface {} {
      "amount": 100,
      "currency": "INR",
      "order_id": "order_Ee0biRtLOqzRjP",
      "email": "gaurav.kumar@example.com",
      "contact": "9000090000",
      "method": "upi",
      "ip": "192.168.0.103",
      "referer": "http",
      "user_agent": "Mozilla/5.0",
      "description": "Test flow",
      "notes": map[string] interface {} {
              "purpose": "UPI test payment",
          },
          "upi": map[string] interface {} {
              "flow": "intent",
          },
  }
  body, err: = client.Payment.CreateUpi(para_attr, nil)
  ```

  ```json Response theme={null}
  {
    "razorpay_payment_id": "pay_CMeM6XvOPGFiF",
    "link": "upi://pay?pa=success@razorpay&pn=xyz&tr=xxxxxxxxxxx&tn=gourav&am=1&cu=INR&mc=xyzw"
  }
  ```
</CodeGroup>

<Warning>
  **Do Not Make Changes to Link Received in Response**

  Do not make changes to the link you receive in the response. This is the Razorpay Intent URL. Making changes to this URL can lead to payment failure or other unexpected errors with the payment.
</Warning>

#### Request Parameters

Following are the request parameters for the API:

`amount` *mandatory*
: `integer` The amount associated with the payment in the smallest unit of the supported currency. For example, 2000 means ₹20.

`currency` *mandatory*
: `string` ISO code of the currency associated with the payment amount. In this case, it is `INR`.

`order_id` *mandatory*
: `string` Unique identifier of the order obtained from the response of the previous step.

`method` *mandatory*
: `string` The payment method used to make the payment. Possible values:

* `netbanking`
* `upi`

<Info>
  **`method` is Required at Both Order and Payment Level for TPV**

  For TPV businesses, `method=upi` must be explicitly passed here in the payment initiation request, in addition to the Create Order request in Step 1. This is mandatory for correct bank code resolution across all banks, including long-tail banks.
</Info>

`notes` *optional*
: `json object` Key-value pair used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`description` *optional*
: `string` Descriptive text of the payment.

`contact` *mandatory*
: `string` Phone number of the customer.

`email` *mandatory*
: `string` Email address of the customer.

`callback_url` *optional*
: `string` URL where Razorpay will submit the final payment status.

`ip` *mandatory*
: `string` The client's browser IP address. For example, **117.217.74.98**

`referer` *mandatory*
: `string` Value of the `referer` header passed by the client's browser. For example, **[https://example.com/](https://example.com/)**.

`user_agent` *mandatory*
: `string` Value of the `user_agent` header passed by client's browser. For example, **Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.130 Safari/537.36**

`upi` *mandatory*
: Details of the UPI payment

`flow`
: `string` Type of the UPI method. In this case, it is `intent`.

You will get the UPI Intent URI as part of the payment response.

To pass the payment data to the respective UPI app and to initiate the payment, use the following code:

```javascript Pass data to UPI app theme={null}
Intent i = new Intent(Intent.ACTION_VIEW);
        i.setData(Uri.parse(url)); //uri from the create S2S payment response
        i.setPackage(packageName); //package name from the `upi://pay` intent response

activity.startActivityForResult(i,2561); //unique activity code to get the callback
```

### Step 3: Store Fields in Your Server

A successful payment returns the following fields to the Checkout form.

<AccordionGroup>
  <Accordion title="Success Callback">
    * You need to store these fields in your server.
    * You can confirm the authenticity of these details by verifying the signature in the next step.

    <CodeGroup>
      ```json Success Callback theme={null}
      {
        "razorpay_payment_id": "pay_29QQoUBi66xm2f",
        "razorpay_order_id": "order_9A33XWu170gUtm",
        "razorpay_signature": "9ef4dffbfd84f1318f6739a3ce19f9d85851857ae648f114332d8401e0949a3d"
      }
      ```
    </CodeGroup>

    <br />

    `razorpay_payment_id`
    : `string` Unique identifier for the payment returned by Checkout **only** for successful payments.

    `razorpay_order_id`
    : `string` Unique identifier for the order returned by Checkout.

    `razorpay_signature`
    : `string` Signature returned by the Checkout. This is used to verify the payment.
  </Accordion>
</AccordionGroup>

### Step 4: Verify the Payment Signature

This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.

<AccordionGroup>
  <Accordion title="To verify the `razorpay_signature` returned to you by the Checkout form:">
    1. Create a signature in your server using the following attributes:
       * `order_id`: Retrieve the `order_id` from your server. Do not use the `razorpay_order_id` returned by Checkout.
       * `razorpay_payment_id`: Returned by Checkout.
       * `key_secret`: Available in your server. The `key_secret` that was generated from the [Dashboard](/docs/payments/dashboard/account-settings/api-keys#generate-api-keys).

    2. Use the SHA256 algorithm, the `razorpay_payment_id` and the `order_id` to construct a HMAC hex digest as shown below:

    ```html HMAC Hex Digest theme={null}
    generated_signature = hmac_sha256(order_id + "|" + razorpay_payment_id, secret);

      if (generated_signature == razorpay_signature) {
        payment is successful
      }
    ```

    3. If the signature you generate on your server matches the `razorpay_signature` returned to you by the Checkout form, the payment received is from an authentic source.
  </Accordion>
</AccordionGroup>

<AccordionGroup>
  <Accordion title="Generate Signature on Your Server">
    Given below is the sample code for payment signature verification:

    <CodeGroup>
      ```java Java theme={null}
      RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      String secret = "EnLs21M47BllR3X8PSFtjtbd";

      JSONObject options = new JSONObject();
      options.put("razorpay_order_id", "order_IEIaMR65cu6nz3");
      options.put("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
      options.put("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f");

      boolean status =  Utils.verifyPaymentSignature(options, secret);
      ```

      ```php PHP theme={null}
      $api = new Api($key_id, $secret);

      $api->utility->verifyPaymentSignature(array('razorpay_order_id' => $razorpayOrderId, 'razorpay_payment_id' => $razorpayPaymentId, 'razorpay_signature' => $razorpaySignature));
      ```

      ```ruby Ruby theme={null}
      require "razorpay"
      Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

      payment_response = {
             razorpay_order_id: 'order_IEIaMR65cu6nz3',
             razorpay_payment_id: 'pay_IH4NVgf4Dreq1l',
             razorpay_signature: '0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f'
           }
      Razorpay::Utility.verify_payment_signature(payment_response)
      ```

      ```python Python theme={null}
      import razorpay
      client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

      client.utility.verify_payment_signature({
        'razorpay_order_id': razorpay_order_id,
        'razorpay_payment_id': razorpay_payment_id,
        'razorpay_signature': razorpay_signature
        })
      ```

      ```c .NET theme={null}
      RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      Dictionary<string, string> options = new Dictionary<string, string>();
      options.Add("razorpay_order_id", "order_IEIaMR65cu6nz3");
      options.Add("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
      options.Add("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f");

      Utils.verifyPaymentSignature(options);
      ```

      ```javascript Node.js theme={null}
      var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

      var { validatePaymentVerification, validateWebhookSignature } = require('./dist/utils/razorpay-utils');
      validatePaymentVerification({"order_id": razorpayOrderId, "payment_id": razorpayPaymentId }, signature, secret);
      ```

      ```go Go theme={null}
      import ( razorpay "github.com/razorpay/razorpay-go" )
      client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

      params := map[string]interface{}{
       "razorpay_order_id": "order_IEIaMR65cu6nz3",
       "razorpay_payment_id": "pay_IH4NVgf4Dreq1l",
      }

      signature := "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f";
      secret := "EnLs21M47BllR3X8PSFtjtbd";
      utils.VerifyPaymentSignature(params, signature, secret)
      ```
    </CodeGroup>
  </Accordion>
</AccordionGroup>

<AccordionGroup>
  <Accordion title="Post Signature Verification">
    After you have completed the integration, you can [set up webhooks](/docs/webhooks/setup-edit-payments), make test payments, replace the test key with the live key and integrate with other [APIs](/docs/api).
  </Accordion>
</AccordionGroup>

### Payment Capture Settings

After payment is `authorized`, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.

<Warning>
  **Watch Out**

  * You should deliver the products or services to your customers only after the payment is captured. Razorpay automatically refunds all the uncaptured payments.
  * You can track the payment status using our [Fetch a Payment API](/docs/api/payments#fetch-a-payment) or webhooks.
</Warning>

<Tabs>
  <Tab title="Auto-capture Payments (Recommended)">
    Authorized payments can be automatically captured. You can auto-capture all payments [using global settings](/docs/payments/payments/capture-settings#auto-capture-all-payments) on the Razorpay Dashboard. Know more about [capture settings for payments](/docs/payments/payments/capture-settings).

    <Warning>
      **Watch Out!**

      Payment capture settings work only if you have integrated with Orders API on your server side. Know more about the [Orders API](/docs/api/orders/create).
    </Warning>
  </Tab>

  <Tab title="Manually Capture Payments">
    Each authorized payment can also be captured individually. You can manually capture payments using [Payment Capture API](/docs/api/payments/capture) or [Dashboard](/docs/payments/payments/dashboard#manually-capture-payments). Know more about [capture settings for payments](/docs/payments/payments/capture-settings).
  </Tab>
</Tabs>

### Related Information

* [Webhooks](/docs/webhooks) (Recommended)
* [Error Codes](/docs/errors) (Recommended)
* [How Payment Gateway Works](/docs/payments/payment-gateway/how-it-works)
* [Payment States](/docs/payments/payments)
* [Settlements](/docs/payments/settlements)
* [Refunds](/docs/payments/refunds)
